Last Comment Bug 756243 - IonMonkey: Assertion failure: kind == GetGCThingTraceKind(*thingp), at gc/Marking.cpp:231
: IonMonkey: Assertion failure: kind == GetGCThingTraceKind(*thingp), at gc/Mar...
Status: VERIFIED FIXED
[jsbugmon:update]
: assertion, sec-high, testcase
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: Other Branch
: x86_64 Linux
: -- major (vote)
: ---
Assigned To: David Anderson [:dvander]
:
: Jason Orendorff [:jorendorff]
Mentors:
Depends on:
Blocks: langfuzz IonFuzz
  Show dependency treegraph
 
Reported: 2012-05-17 13:23 PDT by Christian Holler (:decoder)
Modified: 2013-03-11 07:00 PDT (History)
6 users (show)
choller: in‑testsuite-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
unaffected


Attachments
fix (1.28 KB, patch)
2012-05-17 15:08 PDT, David Anderson [:dvander]
no flags Details | Diff | Splinter Review
better fix (1.83 KB, patch)
2012-05-17 17:04 PDT, David Anderson [:dvander]
nicolas.b.pierron: review+
Details | Diff | Splinter Review

Description Christian Holler (:decoder) 2012-05-17 13:23:10 PDT
The following testcase asserts on ionmonkey revision 14735b4dbccc (run with --ion -n -m):


function enterFunc (funcName)
    funcName += "()";
var lfcode = new Array();
gczeal(2);
evaluate("test();\
function test() {\
  enterFunc ('test');\
  (new test('(a(b(c)))(d(e(f)))\\\\2\\\\5'));\
}\
");
Comment 1 David Anderson [:dvander] 2012-05-17 14:58:24 PDT
This is some kind of horrible bug involving invalidation, gc - we're restoring a value to the interpreter stack which has been freed. Investigating.
Comment 2 David Anderson [:dvander] 2012-05-17 15:08:11 PDT
Created attachment 624917 [details] [diff] [review]
fix

Another simple off-by-N bug.
Comment 3 David Anderson [:dvander] 2012-05-17 17:04:20 PDT
Created attachment 624958 [details] [diff] [review]
better fix
Comment 4 Nicolas B. Pierron [:nbp] 2012-05-17 18:39:20 PDT
Comment on attachment 624958 [details] [diff] [review]
better fix

Review of attachment 624958 [details] [diff] [review]:
-----------------------------------------------------------------

Good, would be better if you can define

JSFunction *fun = maybeCalleeTokenToFunction(layout->calleeToken());
Comment 5 David Anderson [:dvander] 2012-05-18 01:32:23 PDT
http://hg.mozilla.org/projects/ionmonkey/rev/8c54899dae82
Comment 6 Christian Holler (:decoder) 2012-05-18 04:35:24 PDT
JSBugMon: This bug has been automatically verified fixed.
Comment 7 Christian Holler (:decoder) 2013-03-11 07:00:09 PDT
Early ion gc issue, in-testsuite-.

Note You need to log in before you can comment on or make changes to this bug.